const utils = require('./utils')
const stderrNamespace = utils.stderrNamespace
const spawn = require('child_process').spawn

/**
 * Spawn a set of demo processes
 */

stderrNamespace('scenario:SharkAttack', spawn('nsolid', [
  'bin/simulate.js',
  'test/simulator/scenarios/noop.js@15'
], {
  env: Object.assign({}, process.env, {
    NSOLID_APPNAME: 'Shark Attack',
    NSOLID_TAGS: 'and some more, and something else, break that line, DC, frep, gogogogo, Grey Shark, implicits, more, polygon skeleton, splines, surface boundary, us-east-1, voronoi'
  })
}))

stderrNamespace('scenario:SharkAttack', spawn('nsolid', [
  'bin/simulate.js',
  'test/simulator/scenarios/noop.js@5'
], {
  env: Object.assign({}, process.env, {
    NSOLID_APPNAME: 'Shark Attack',
    NSOLID_TAGS: 'us-west-1, White Shark'
  })
}))

stderrNamespace('scenario:Beeeeeeeees', spawn('nsolid', [
  'bin/simulate.js',
  'test/simulator/scenarios/leaky-http.js@10'
], {
  env: Object.assign({}, process.env, {
    NSOLID_APPNAME: 'Beeeeeeeees',
    NSOLID_TAGS: 'us-east-1, Big Bees'
  })
}))

stderrNamespace('scenario:PersnicketyPorcupine', spawn('nsolid', [
  'bin/simulate.js',
  'test/simulator/scenarios/security-vulnerability.js@2',
  'test/simulator/scenarios/another-vuln.js@2'
], {
  env: Object.assign({}, process.env, {
    NSOLID_APPNAME: 'Persnickety Porcupine',
    NSOLID_TAGS: 'defense, production, prod, animal, mammal, rodent, spines, brown, grey, white'
  })
}))

const nodeEnv = process.env.NODE_ENV

if (nodeEnv !== 'production') {
  stderrNamespace('scenario:PersnicketyPorcupine', spawn('nsolid', [
    'bin/simulate.js',
    'test/simulator/scenarios/process-cycling.js@2',
    'test/simulator/scenarios/another-vuln.js@2'
  ], {
    env: Object.assign({}, process.env, {
      NSOLID_APPNAME: 'Demanding Dimetrodon'
    })
  }))
}
