const hub = require('../hub')
module.exports = profile

function profile (cache, appConfig, proc, duration, fn) {
  const args = { app: proc.app, id: proc.id }
  const hubUrl = cache.getHubByProcessId(proc.id)

  hub.command('profile_start', args, hubUrl, appConfig, (e) => {
    if (e) {
      return fn(e)
    }

    setTimeout(function waitForProfileDuration () {
      const meta = cache.getResourceMetaFromProcess(proc, 'cpuprofile')
      const profileStream = hub.createStream('profile_stop', args, hubUrl, appConfig)
      cache.createFileResourceWriteStream('profiles', meta, (err, resourceStream) => {
        if (err) {
          return fn(err)
        }

        profileStream.pipe(resourceStream)

        profileStream.on('error', fn)
        resourceStream.on('error', fn)
        resourceStream.on('finish', () => { fn(null, meta) })
      })
    }, duration)
  })
}
