const hub = require('../hub')
module.exports = snapshot

const TIMEOUT = 60 * 1000

function snapshot (cache, appConfig, proc, fn) {
  const args = {
    app: proc.app,
    id: proc.id,
    timeout: TIMEOUT
  }
  const hubUrl = cache.getHubByProcessId(proc.id)
  const meta = cache.getResourceMetaFromProcess(proc, 'heapsnapshot')
  const snapshotStream = hub.createStream('snapshot', args, hubUrl, appConfig)
  cache.createFileResourceWriteStream('snapshots', meta, (err, resourceStream) => {
    if (err) {
      return fn(err)
    }

    snapshotStream.pipe(resourceStream)

    snapshotStream.on('error', fn)
    resourceStream.on('error', fn)
    resourceStream.on('finish', () => { fn(null, meta) })
  })
}
