/**
 * In-memory data store that merges new data with existing data.
 */

var merge = require('merge')

module.exports = createArrayStore

function createArrayStore (start) {
  var array = []
  var map = {}

  function getByName (name, value) {
    if (typeof map[name] === 'undefined') {
      if (value) {
        map[name] = merge(true, {
          time: Date.now()
        }, start, value)
        array.push(map[name])
      } else {
        return null
      }
    } else {
      merge(map[name], value)
    }

    return map[name]
  }

  getByName.array = array
  getByName.has = function (name) {
    return !!map[name]
  }

  return getByName
}
