'use strict'

const spawn = require('child_process').spawn

const MAX = 5
const MIN_ALIVE = 20 // seconds
const MAX_ALIVE = 50 // seconds
const KILL_CHANCE = 0.5

let processes = new Set()

setInterval(() => {
  if (processes.size > MAX) return
  const child = spawnChild()
  child.once('exit', () => {
    processes.delete(child)
  })
  processes.add(child)
}, 1000)

function spawnChild () {
  return spawn('nsolid', [
    // spawn some with security vulnerability
    Math.random() < 0.5
    ? 'test/simulator/scenarios/unstable.js'
    : 'test/simulator/scenarios/unstable-security-vulnerability.js'
  ], {
    env: Object.assign({
      NSOLID_APPNAME: 'Demanding Dimetrodon'
    }, process.env)
  })
}
